/*
 * Command line library for Arduino.
 */

#ifndef cli_h
#define cli_h

#include "WProgram.h"
#include <avr/pgmspace.h>

#define COMMAND_LENGTH 10
#define BUFFER_LENGTH 64

typedef void (*CommandProc)();


extern const char *commandMap[];
extern const char *commandHelp[];
extern const CommandProc commandProcMap[];
extern const char commandMapSize;

class Cli
{
  public:
    Cli(char *, Print *);
    void addChar(char c);
    char *getArg(char n);
    char *getArg();
    char *prompt;
    Print *printfunc;

  private:
    void _clear();
    char _cliBuffer[BUFFER_LENGTH];
    unsigned char _cliBufferLength;
    char _commandBuffer[COMMAND_LENGTH];
    char _argBuffer[COMMAND_LENGTH];
    char _strlen(const char *);
    void _strclr(char *, char);
    char _strncmp(const char *, const char *, char);
    void _parseAndRun();
};

#endif
